package nl.Function1.PC.PolePass;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;

// Geez. Looking at something that you coded earlier, is weird. What was I thinking?
public final class Compass extends JavaPlugin implements Listener{
	CollectionList list = new CollectionList(); // field = player to follow, value = player to update

	public void onEnable(){
		Bukkit.getServer().getPluginManager().registerEvents(this, this);
	}
	
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args){
		if (cmd.getName().equalsIgnoreCase("compass")){
			if (sender instanceof Player){
				Player p = (Player) sender;
				Direction toSet = null;
				
				if (args.length > 0){
					if (args[0].toLowerCase().startsWith("f")){		//   FOLLOW
						if (args.length > 1){
							Player toFollow = Bukkit.getServer().getPlayer(args[1]);
							if (toFollow != null){
								if (list.getValue(toFollow.getName()) == null){ // Prevent duplicates
									list.add(toFollow.getName(), p.getName());
									p.setCompassTarget(toFollow.getLocation());
									p.sendMessage("You now follow " + toFollow.getName() + " with your compass.");
								}
								return true;
							}else{
								p.sendMessage(ChatColor.RED + "\"" + args[1] + "\" is not found on this server");
								return false;
							}
						}else{
							p.sendMessage(ChatColor.RED + "Syntax Error: Please enter a player to follow with your compass.");
							return false;
						}
					}
					else if (args[0].equalsIgnoreCase("help")){      //	  HELP
						p.sendMessage(ChatColor.GOLD + "/compass [direction]" + ChatColor.GRAY + 
								" - sets your compass direction to North, West, East or South.");
						p.sendMessage(ChatColor.GOLD + "/compass pos <x> <y> <z>" + ChatColor.GRAY + 
								" - sets your compass direction to the specific location.");
						p.sendMessage(ChatColor.GOLD + "/compass pos current" + ChatColor.GRAY + " - sets your compass direction to your current position.");
						p.sendMessage(ChatColor.GOLD + "/compass follow <player>" + ChatColor.GRAY + " - sets your compass direction to someone else's" +
								" position. Keeps updating.");
						p.sendMessage(ChatColor.GOLD + "/polecompass" + ChatColor.GRAY + " - views the info of the plugin.");
						p.sendMessage(ChatColor.GOLD + "To make your compass normal again, use /compass [reset].");
						return true;
					}
					else if (args[0].toLowerCase().startsWith("n")){ //   NORTH
						toSet = Direction.North;
					}
					else if (args[0].toLowerCase().startsWith("e")){ //   EAST
						toSet = Direction.East;
					}
					else if (args[0].toLowerCase().startsWith("s")){ //   SOUTH
						toSet = Direction.South;
					}
					else if (args[0].toLowerCase().startsWith("w")){ //   WEST
						toSet = Direction.West;
					}
					else if (args[0].toLowerCase().startsWith("r")){ //   RESET
						removePlayer(p);
						toSet = Direction.None;
					}
					else if (args[0].equalsIgnoreCase("pos")){ //special location 
						if (args.length > 1){
							if (args[1].toLowerCase().startsWith("c")){
								p.setCompassTarget(p.getLocation());
								return true;
							}
						}
						//if it's not, this will be executed.
						try{
							int x = Integer.parseInt(args[1]);
							int y = Integer.parseInt(args[2]);
							int z = Integer.parseInt(args[3]);
							p.setCompassTarget(p.getWorld().getBlockAt(x,y,z).getLocation());
							return true;
						}catch (Exception ex){
							p.sendMessage(ChatColor.RED + "Failed to convert positions");
							return true;
						}
					}
					else if (args[0].equalsIgnoreCase("playerpos")){ // Set other player's compass.
						if (args.length > 1){
							Player target = Bukkit.getServer().getPlayer(args[1]);
							if (target == null){
								p.sendMessage(ChatColor.RED + "Player \"" + args[1] + "\" not found");
								return true; // That message sucks.
							}else if (args.length > 2) {
								if (args[2].toLowerCase().startsWith("c")){
									target.setCompassTarget(target.getLocation());
								}else if (args.length > 4){
									try{
										int x = Integer.parseInt(args[2]);
										int y = Integer.parseInt(args[3]);
										int z = Integer.parseInt(args[4]);
										target.setCompassTarget(p.getWorld().getBlockAt(x,y,z).getLocation());
										p.sendMessage("Succesfully given the compass target of \"" + p.getName() + "\" to positions " + x + ", " + y + 
												", " + z + ".");
										return true;
										}catch (Exception ex){
										p.sendMessage(ChatColor.RED + "Failed to convert positions");
										return true;
									}
								}
							}else{
								p.sendMessage(ChatColor.RED + "Location not given or complete");
								return false;
							}
						}else {
							p.sendMessage(ChatColor.RED + "Player not specified");
							return false;
						}
					}
				}else{
					removePlayer(p);
					toSet = Direction.None;
				}
				
				if (toSet != null){
						setCompassToDirection(p, toSet);
				}else{
					p.sendMessage(ChatColor.RED + "\"" + args[0] + "\" is not a valid direction."); // Now you think "What if args[0] is equal to null?"
					return false;															        // well, it can't be null. Look at the code.
				}
			}else{
				sender.sendMessage("You cannot use this command if you aren't a player.");
			}
			return true;
		}else if (cmd.getName().equalsIgnoreCase("polecompass")){
			PluginDescriptionFile pdf = this.getDescription();
			String name = "PoleCompass";
			String des = pdf.getDescription();
			String ver = pdf.getVersion();
			String url = pdf.getWebsite();
			String aut = pdf.getAuthors().get(0);
			
			if (sender instanceof Player){
				Player p = (Player) sender;
				p.sendMessage(ChatColor.AQUA + name + " " + ver);
				p.sendMessage(ChatColor.GOLD + des);
				p.sendMessage(ChatColor.GOLD + "Author: " + aut);
				p.sendMessage(ChatColor.GOLD + "URL: " + url);
			}else{
				sender.sendMessage(name + " " + ver);
				sender.sendMessage(des);
				sender.sendMessage("Author: " + aut);
				sender.sendMessage("URL: " + url);
			}
		}
		return false;
	}
	
	@EventHandler
	public void onPlayerMove(PlayerMoveEvent e){
		Player p = e.getPlayer();
		String nameOfTargetToUpdate = list.getValue(p.getName());
		if (nameOfTargetToUpdate != null){
			Player toUpdate = Bukkit.getServer().getPlayer(nameOfTargetToUpdate);
			if (toUpdate != null){
				toUpdate.setCompassTarget(p.getLocation());
				toUpdate.sendMessage(toUpdate.getName());
				toUpdate.sendMessage(p.getName());
			}else{
				removePlayer(p); // Player logged out, or vanished.
			}
		}
	}
	
	private void removePlayer(Player p){
		list.remove(p.getName());
	}
	
	private void setCompassToDirection(Player p, Direction direction){
		Location loc = p.getLocation();
		switch (direction) {
		
		case North:
			p.setCompassTarget(p.getWorld().getBlockAt((int)loc.getX(), 0, -12550820).getLocation());
			break;
		case East:
			p.setCompassTarget(p.getWorld().getBlockAt(12550820, 0, (int)loc.getZ()).getLocation());
			break;
		case South:
			p.setCompassTarget(p.getWorld().getBlockAt((int)loc.getX(), 0, 12550820).getLocation());
			break;
		case West:
			p.setCompassTarget(p.getWorld().getBlockAt(-12550820, 0, (int)loc.getZ()).getLocation());
			break;
		default:
			if (p.getBedSpawnLocation() != null){
				p.setCompassTarget(p.getBedSpawnLocation());
			}else{
				p.setCompassTarget(p.getWorld().getSpawnLocation());
			}			
			break;
		}
	}
	
	private enum Direction{
		None,North,East,South,West;
	}
}
